#!C:/strawberry/perl/bin/perl.exe
                              
#Skriptname:  go_read.pl
#Funktion:    Erzeugt HTML Dateien wo sich die struktur von der DB leicht auslesen 
#             lsst und dazu noch insert befehele etc. vorgegeben werden fr perl
#Autor:       Jrg Hfner
#Datum:       22.03.2013

use strict;
use lib 'module';
use DBCore;       # DBCore::do() - DBCore::get_hash() - DBCore::get_hasharray()
use File::Copy;
use File::Copy::Recursive qw(dircopy);

# Verzeichnis mit datenbanken_erg erstellen
my $create_dir_index = mkdir("datenbanken_erg");
if($create_dir_index){ print "Verzeichnis 'datenbanken_erg' erstellt.\n"; }

open INDEX, ">datenbanken_erg\\index.html" or die ("Fehler beim schreiben in html-datei $!");
print INDEX "<!doctype html>
<html lang='de' xml:lang='de'>
<head>
<meta charset='iso-8859-1'>
  <link rel='stylesheet' href='style.css' type='text/css' />
  <meta name='robots' content='noindex, nofollow' />
  <title>Datenbanken - bersicht</title>
  <link href='favicon.ico' rel='shortcut icon' type='image/x-icon' /> 
  <script type='text/javascript' src='js/jquery-1.9.1.min.js'></script>
<script type='text/javascript' src='js/functions.js'></script>
</head>                 
<body>
  <div id='wrapper'>
  <h1>bersicht der Datenbanken</h1>
  
  <ul>";
open FH, "dbs.csv" or die ("Fehler beim ffnen $!");

# style.css kopieren
my $copy_ok = copy("style.css", "datenbanken_erg\\style.css");
if($copy_ok){ print "'style.css' in Verzeichnis kopiert.\n"; }

# favicon.css kopieren
my $copy_favicon = copy("favicon.ico", "datenbanken_erg\\favicon.ico");
if($copy_favicon){ print "'favicon.ico' in Verzeichnis kopiert.\n"; }


my $count = 0;
while(<FH>){
if(++$count == 1){ next; }
my @spaltencsv=split(/\";\"/,$_);
my ($desc, $database, $db_dns, $db_user, $db_passwd);

foreach(@spaltencsv){
  chomp($spaltencsv[4]);
  $desc      = $spaltencsv[0];
  $database  = $spaltencsv[1];
  $db_dns    = $spaltencsv[2];
  $db_user   = $spaltencsv[3];
  $db_passwd = $spaltencsv[4];
}

print INDEX "<li><a href='".$desc."/index.html'>DB: ".$desc."</a></li>";

DBCore::DBConnect( $database ,$db_dns ,$db_user ,$db_passwd );

# Verzeichnis mit datenbanknamen erstellen
my $create_dir = mkdir("datenbanken_erg\\".$desc);
if($create_dir){ print "Verzeichnis 'datenbanken_erg\\".$desc."\' erstellt.\n"; }

if( -e "datenbanken_erg\\".$desc){ 
  # stylesheet fr html-datei kopieren  
  my $copy_ok = copy("style.css", "datenbanken_erg\\".$desc."\\style.css");
  if($copy_ok){ print "'style.css' in Verzeichnis kopiert.\n"; }
  
  # favicon.css kopieren
  my $copy_favicon = copy("favicon.ico", "datenbanken_erg\\".$desc."\\favicon.ico");
  if($copy_favicon){ print "'favicon.ico' in Verzeichnis kopiert.\n"; }  
  
  # Verzeichnis js kopieren
  dircopy("js","datenbanken_erg\\".$desc."\\js") or die $!;
  
  # Tabellenstatus auslesen
  my @tables = DBCore::get_hasharray("SHOW TABLE STATUS FROM ".$database);

  # Erzeuge Startseite der datenbank
  open HOME, ">datenbanken_erg\\".$desc."\\index.html" or die ("Fehler beim schreiben in html-datei $!");
  
  #Header schreiben
  print HOME "
<!doctype html>
<html lang='de' xml:lang='de'>
<head>
<meta charset='iso-8859-1'>
  <link rel='stylesheet' href='style.css' type='text/css' />
  <meta name='robots' content='noindex, nofollow' />
  <title>".$desc.". - Tabellentruktur von Datenbank ".$database."</title>
  <link href='favicon.ico' rel='shortcut icon' type='image/x-icon' /> 
  <script type='text/javascript' src='js/jquery-1.9.1.min.js'></script>
<script type='text/javascript' src='js/functions.js'></script>
</head>                 
<body>
  <div id='wrapper'>
    <h1>Tabellen von Datenbank ".$database."</h1>
    <table id='tablesinfo' cellspacing='1' cellpadding='0'>
      <tr>
        <th align='left'>Tabellenname</th>
        <th align='left'>Eintrge</th>
        <th align='left'>Data_length</th>
        <th align='left'>Auto_increment</th>     
        <th align='left'>Engine</th>
        <th align='left'>Collation</th>   
        <th align='left'>erstellt am</th></tr>";
  foreach(@tables){    
    print HOME "<tr>
        <td align='left' class='link'><a href='".$_->{Name}.".html' title='zur Tabelle'>".$_->{Name}."</a></td>
        <td align='left'>".$_->{Rows}."</td>
        <td align='left'>".$_->{Data_length}."</td>
        <td align='left'>".$_->{Auto_increment}."</td>       
        <td align='left'>".$_->{Engine}."</td>
        <td align='left'>".$_->{Collation}."</td>
        <td align='left'>".$_->{Create_time}."</td>
      </tr>";        
  }  
  print HOME "
     </table>
  ";
  print "Startdatei 'index.html' erstellt.'\n";
  
  foreach(@tables){  
    # tabelleninfo auslesen
    my @table_info = DBCore::get_hasharray("DESCRIBE ".$_->{Name}); 
    
    # Erzeuge Startseite
    open TABLEHTML, ">datenbanken_erg\\".$desc."\\".$_->{Name}.".html" or die ("Fehler beim schreiben in html-datei $!");
    print HOME "<div class='table_left'><table cellspacing='1' cellpadding='0'>
                <tr><th align='left' colspan='2' class='link'><a href='".$_->{Name}.".html' title='zur Tabelle'>".$_->{Name}."</a></th></tr>";
    #Header schreiben
    print TABLEHTML "
  <!doctype html>
  <html lang='de' xml:lang='de'>
  <head>
  <meta charset='iso-8859-1'>
    <link rel='stylesheet' href='style.css' type='text/css' />
    <meta name='robots' content='noindex, nofollow' />
    <title>".$desc.". - Tabellen ".$_->{Name}." von Datenbank ".$database."</title>
    <link href='favicon.ico' rel='shortcut icon' type='image/x-icon' /> 
    <script type='text/javascript' src='js/jquery-1.9.1.min.js'></script>
<script type='text/javascript' src='js/functions.js'></script>
  </head>                 
  <body>
    <div id='wrapper_sub'>
      <div style='float:left;font-size: 16px;margin: 10px 0;font-weight: bold;'>Tabellen ".$_->{Name}." von Datenbank ".$database."</div>
      <div id='backbutton'><a href='index.html' title='zurck zur bersicht'>zurck</a></div>
      <div style='clear:both;'></div>
      <table cellspacing='1' cellpadding='0'>
        <tr>
          <th align='left'>Spalte</th>
          <th align='left'>Type</th>
          <th align='left'>Null</th>
          <th align='left'>Key</th>     
          <th align='left'>Default</th>
          <th align='left'>Extra</th></tr>"; 
    my @spalten; 
    my $leerzeichen = "";
    my $anzahl_leerzeichen = length($_->{Name}) + 13;
    my $leerzeichen_select = "";
    my $leerzeichen_update = "";
    foreach(1..$anzahl_leerzeichen){ $leerzeichen .= "&nbsp;"; }
    foreach(1..5){ $leerzeichen_update .= "&nbsp;"; }
    foreach(1..5){ $leerzeichen_select .= "&nbsp;"; }     
    
    my $max_zeichen = 0;
    foreach(@table_info){
      if(length($_->{Field}) > $max_zeichen){ $max_zeichen = length($_->{Field}); }
    }
    $max_zeichen *= 8;
      
    foreach(@table_info){               
        print HOME "<tr><td class='link' align='left'><input style=\"width:".$max_zeichen."px\" class='copyclip' type='text' value='".$_->{Field}."'' readonly /></td><td align='left'>".$_->{Type}."</td></tr>";
        print TABLEHTML "<tr>
        <td align='left'>".$_->{Field}."</td>
        <td align='left'>".$_->{Type}."</td>
        <td align='left'>".$_->{Null}."</td>
        <td align='left'>".$_->{Key}."</td>       
        <td align='left'>".$_->{Default}."</td>
        <td align='left'>".$_->{Extra}."</td>
      </tr>";
      push(@spalten, $_->{Field});  
    }
    print TABLEHTML "
     </table>";
    my $insert = "";
    my $select = "";
    my $update = "";
    my $platzhalter = "";
    foreach(@spalten){
      $insert .= "`".$_."`
".$leerzeichen.", ";
      $select .= "`".$_."`
".$leerzeichen_select.", ";
      $update .= "`".$_."` = ?
".$leerzeichen_update.", ";
      $platzhalter .= " ?,";
    }
    $insert = substr($insert,0,length($insert)-2);
    $update = substr($update,0,length($update)-33);
    $select = substr($select,0,length($select)-33);
    $platzhalter = substr($platzhalter,0,length($platzhalter)-1);
    print TABLEHTML "<p class='desc'>INSERT-Befehl</p>";
    print TABLEHTML "<p class='code'><textarea class='copyclip' rows='".(scalar(@spalten)+1)."' readonly>INSERT INTO ".$_->{Name}." ( ".$insert." ) VALUES (".$platzhalter.")</textarea>";
    print TABLEHTML "</p>";
    print TABLEHTML "<p class='desc'>SELECT-Befehl</p>";
    print TABLEHTML "<p class='code'><textarea class='copyclip' rows='".(scalar(@spalten)+2)."' readonly>SELECT ".$select." 
  FROM ".$_->{Name}."
 WHERE</textarea>";
    print TABLEHTML "</p>";
     print TABLEHTML "<p class='desc'>UPDATE-Befehl</p>";
    print TABLEHTML "<p class='code'><textarea class='copyclip' rows='".(scalar(@spalten)+3)."' readonly>UPDATE ".$_->{Name}."
   SET ".$update." 
  FROM ".$_->{Name}."
 WHERE</textarea>";
    print TABLEHTML "</p>";
    print TABLEHTML "<p class='desc'>DELETE-Befehl</p>";
    print TABLEHTML "<p class='code'><textarea class='copyclip' rows='2' readonly>DELETE FROM ".$_->{Name}." 
      WHERE</textarea>";
    print TABLEHTML "</p>";
    print TABLEHTML "
      </div>
    </head>
    <body>";
    
    print "Tabellendatei '".$_->{Name}.".html' erstellt.'\n";
    
    print HOME "</table></div>";          
  }
  print HOME "<div style='clear:both'></div>";
  # Routines
  my @routines = DBCore::get_hasharray("SELECT SPECIFIC_NAME, ROUTINE_SCHEMA, ROUTINE_NAME, ROUTINE_TYPE, ROUTINE_DEFINITION, CREATED FROM information_schema.ROUTINES ORDER BY ROUTINE_TYPE");
  
  print HOME "<div id='routines'>";
  my $routine_art = "";
  foreach(@routines){
    if($_->{ROUTINE_TYPE} ne $routine_art){
      $routine_art = $_->{ROUTINE_TYPE};
      #print HOME "<p class='routinetyp'>".$routine_art."</p>";
    }
    my @split = split(/\n/,$_->{ROUTINE_DEFINITION}); 
    print HOME "<p class='desc'>".$routine_art.": <strong>".$_->{ROUTINE_SCHEMA}.".".$_->{ROUTINE_NAME}."</strong> erstellt am ".$_->{CREATED}."</p>";
    print HOME "<p class='code'><textarea class='copyclip' rows='".(scalar(@split))."' readonly>";    
    foreach(@split){
      print HOME $_;
    }
    print HOME "</textarea></p>";
    
  }
   
  
  print HOME "
  </div>
</head>
<body>";
  close HOME;
  
}else{
  print "FEHLER: Verzeichnis 'datenbanken_erg\\".$database."\' existiert nicht.\n";  
}
}
close FH;

print INDEX "</ul>  
  </div>
</body>
</html>";
close INDEX;